﻿using System;

namespace _01OperatorOverloading
{
    class Bruch
    {
        private int z, n;
        public Bruch(int Z, int N = 1)
        {
            z = Z;
            if (N == 0)
                throw new ArgumentNullException("Nenner darf nicht 0 sein!");
            n = N;
        }
        public Bruch(string t)
        {
            string[] d = t.Split('/');
            z = Convert.ToInt32(d[0]);
            n = Convert.ToInt32(d[1]);
        }

        public static Bruch Mult1(Bruch b1, Bruch b2)
        {
            int zaehler = b1.z * b2.z;
            int nenner = b1.n * b2.n;

            //b1.z = zaehler;
            //b1.n = nenner;
            Bruch erg = new Bruch(zaehler, nenner);
            return erg;
        }
        public static Bruch Mult2(Bruch b1, Bruch b2)
        {
            return new Bruch(b1.z * b2.z, b1.n * b2.n);
        }
        public static Bruch Mult(Bruch b1, Bruch b2)
            => new Bruch(b1.z * b2.z, b1.n * b2.n);
        public static Bruch operator *(Bruch b1, Bruch b2)
            => new Bruch(b1.z * b2.z, b1.n * b2.n);
        public static bool operator ==(Bruch b1, Bruch b2)
            => b1.z == b2.z && b1.n == b2.n;
        // nur wenn b1.z == b2.z ist, wird b1.n == b2.n ausgeführt
        public static bool operator !=(Bruch b1, Bruch b2)
            => !(b1 == b2);

        // Konvertierungsoperatoren:
        public static explicit operator int(Bruch b)
            => b.z / b.n;
        public static implicit operator double(Bruch b)
            => (double)b.z / (double)b.n;
        public static implicit operator Bruch(int zahl)
            => new Bruch(zahl);


    }


    class Program
    {
        static void Main(string[] args)
        {
            Bruch b1 = new Bruch(2, 3);
            Bruch b2 = new Bruch(2);
            Bruch b3 = new Bruch("3/4");

            // Bruch e1 = b1.Mult(b2);   // wäre möglich
            // Bruch e1 = b1.Mult(2);    // ist möglich
            // Bruch e1 = 3.Mult(b1);    // ist nicht möglich, da 3 vom Typ int und nicht Bruch ist
            Bruch e2 = Bruch.Mult(b1, b2);
            //Bruch e2 = Bruch.Mult(2,  b2);  // nicht nötig, über Konv.Op. erledigt
            //Bruch e2 = Bruch.Mult(b1, 2);   // nicht nötig, über Konv.Op. erledigt

            Bruch e3 = b1 * b2;
            Bruch e4 = b1 * 2;
            Bruch e5 = 2 * b1;
            // Wir haben Bruch.operator*(Bruch, Bruch)
            // int.op*, double.op*, Bruch.op*
            // Bruch.op*(Bruch, Bruch)
            //      int->Bruch, Bruch   ???
            // 2 --> impl.Konv. --> Bruch
            // op* (Bruch, Bruch)
            // double.op*(int, double)  --> double.op*(int-->double, double)
            int k2 = 3 * (int)4.5;

            int k = (int)e3;   // explizite Konvertierung
            double d = e3;      // implizite Konvertierung
            Console.WriteLine(k);
            Console.WriteLine(d);

            double d2 = (int)34;
            int k3 = (int)3.5;

            Bruch b4 = new Bruch(2, 5);         // b4: neuer Speicher #100000
            Bruch b5 = new Bruch(2, 5);         // b5: neuer Speicher #200000
            if (b4 == b5)
                Console.WriteLine("Sind gleich");
            else
                Console.WriteLine("Sind unterschiedlich");
        }
    }
}
